unit facade_class;

interface

uses db, forms, Classes;

type
  TDataFacade = class
  private
    datam: TDataModule;
    function GetValue(FieldName: string): string;
    procedure SetValue(FieldName: string; const Value: string);
  public
    constructor Create (dm1: TDataModule);
    property Value [FieldName: string]: string
      read GetValue write SetValue; default;
  end;

implementation

{ TDataFacade }

constructor TDataFacade.Create(dm1: TDataModule);
begin
  datam := dm1;
end;

function TDataFacade.GetValue(FieldName: string): string;
var
  i: integer;
  field: TField;
begin
  Result := '[not found]';
  for i := 0 to datam.ComponentCount - 1 do
  begin
    if datam.components [i] is TDataSet then
    begin
      field := TDataSet(datam.components [i]).
        FindField (FieldName);
      if Assigned (Field) then
      begin
        Result := Field.AsString;
        break;
      end;
    end;
  end;
end;

procedure TDataFacade.SetValue(FieldName: string; const Value: string);
begin
  // later
end;

end.
