unit MultiCast;

interface

uses
  Classes, Controls, Contnrs, StdCtrls, SysUtils;

type
  TMcButton = class (TButton)
  private
    FMultiClicks: TObjectList;
    procedure SetMultiClick(const Value: TNotifyEvent);
//    function GetMultiClick: TNotifyEvent;
  public
    constructor Create (AOwner: TComponent); override;
    procedure Click; override;
  // published
    property MultiClick: TNotifyEvent {read GetMultiClick}
      write SetMultiClick;
  end;

implementation

type
  TEvtObj = class (TPersistent)
  public
    AnObject: TObject;
    AMethod: TNotifyEvent;
    constructor Create (Obj: TObject; Meth: TNotifyEvent);
  end;

procedure TMcButton.Click;
var
  I: Integer;
begin
  inherited;
  // fire all event handlers
  for I := 0 to FMultiClicks.Count - 1 do
    (FMultiClicks.Items [I] as TEvtObj).AMethod (self)
end;

constructor TMcButton.Create(AOwner: TComponent);
begin
  inherited;
  FMultiClicks := TObjectList.Create;
end;

{
function TMcButton.GetMultiClick: TNotifyEvent;
begin

end;
}

procedure TMcButton.SetMultiClick(const Value: TNotifyEvent);
var
  Obj: TObject;
  Found: Boolean;
  I: Integer;
begin
  Found := False;
  Obj := TObject (TMethod(Value).Data);
  if Assigned (TMethod(Value).Code) then
  begin
    // add new handler or replace existing
    for I := 0 to FMultiClicks.Count - 1 do
      if (FMultiClicks.Items [I] as TEvtObj).AnObject = Obj then
      begin
        Found := True;
        (FMultiClicks.Items [I] as TEvtObj).AMethod := Value;
        break;
      end;

    if not Found then
      FMultiClicks.Add (TEvtObj.Create (Obj, Value));
  end
  else
    // remove handler
    for I := 0 to FMultiClicks.Count - 1 do
      if (FMultiClicks.Items [I] as TEvtObj).AnObject = Obj then
      begin
        FMultiClicks.Remove (FMultiClicks.Items [I]);
        break;
      end;

end;

{ TEvtObj }

constructor TEvtObj.Create(Obj: TObject; Meth: TNotifyEvent);
begin
  AnObject := Obj;
  AMethod := Meth;
end;

end.
