unit MultiCastForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MultiCast, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    btn: TMcButton;
  public
    procedure One(Sender: TObject);
    procedure Two(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

uses anotherform;

{$R *.DFM}

type
  THandlerClass = class (TComponent)
    procedure Three(Sender: TObject);
    procedure Four(Sender: TObject);
  end;

function RemoveMe (Obj: TObject): TNotifyEvent;
begin
  TMethod(Result).Data := Obj;
  TMethod(Result).Code := nil;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  hc: THandlerClass;
begin
  btn := TMcButton.Create (self);

  with btn do
  begin
    Parent := self;
    SetBounds (10, 10, 200, 80);
    Caption := 'Press me';
  end;

  // standard handler
//  btn.OnClick := One;

  // special handler
  btn.MultiClick := Two;

  Form2 := TForm2.Create (Application);
  btn.MultiClick := Form2.FormClick;

  // reassign both
  hc := THandlerClass.Create (self);
  btn.MultiClick := hc.Four;
end;

procedure THandlerClass.Four(Sender: TObject);
begin
  ShowMessage ('Four');
end;

procedure TForm1.One(Sender: TObject);
begin
  ShowMessage ('One');
end;

procedure THandlerClass.Three(Sender: TObject);
begin
  ShowMessage ('Three');
end;

procedure TForm1.Two(Sender: TObject);
begin
  ShowMessage ('Two');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  btn.MultiClick := RemoveMe (form2);
end;

end.
