unit mainform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, StdCtrls, DbTables;

type
  TDbContainer = class (TComponent)
  private
    fTable: TTable;
    FTableName: string;
    procedure SetTableName(const Value: string);
    function GetTableName: string;
    function GetTable: TTable;
  public
    constructor Create (AOwner: TComponent); override;
    destructor Destroy; override;

    property TableName: string
      read GetTableName write SetTableName;
    property Table: TTable read GetTable;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    DbContainer1: TDbContainer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ DbContainer }

constructor TDbContainer.Create(AOwner: TComponent);
begin
  inherited;
  // delayed
  // fTable := TTable.Create (nil);
  // fTable.DataBaseName := 'DBDEMOS';
end;

destructor TDbContainer.Destroy;
begin
  inherited;
  fTable.Free;
end;

function TDbContainer.GetTable: TTable;
begin
  if not Assigned (FTable) then
  begin
    // lazy initialization
    fTable := TTable.Create (nil);
    fTable.DataBaseName := 'DBDEMOS';
  end;
  Result := fTable;
end;

function TDbContainer.GetTableName: string;
begin
  Result := Table.TableName;
end;

procedure TDbContainer.SetTableName(const Value: string);
begin
  Table.TableName := Value;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DbContainer1.TableName := 'country.db';
  DataSource1.Dataset := DbContainer1.Table;
  DataSource1.Dataset.Open;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DbContainer1 := TDbContainer.Create (self);
end;

end.
