unit iter;

interface

uses
  classes, controls;

type
  IIterator = interface
    ['{354A6E9A-751F-445D-B200-64228BA8E21D}']
    function Next: Boolean;
    function Get: TComponent;
  end;

type
  TChildIt = class (TInterfacedObject, IIterator)
  private
    root, CurrentObj: TControl;
    Item: Integer;
    function BackToParent: Boolean;
  public
    constructor Create (MainObj: TControl);
    function Next: Boolean;
    function Get: TComponent;
  end;

implementation

{ TChildIt }

constructor TChildIt.Create(MainObj: TControl);
begin
  CurrentObj := MainObj;
  root := CurrentObj;
//  if (CurrentObj is TWinControl)
//    and ((CurrentObj as TWinControl).ControlCount > 0) then
//      Item := -1
//  else
    Item := -1;
end;

function TChildIt.Get: TComponent;
begin
  if Item >= 0 then
    Result := (CurrentObj as TWinControl).Controls [Item]
  else
    Result := nil;
end;

function TChildIt.BackToParent: Boolean;
var
  i: Integer;
  childcontrol: TControl;
begin
  Result := True;
  if CurrentObj = root then
  begin
    Result := False;
  end
  else
  begin
    childControl := CurrentObj;
    // get back to parent
    CurrentObj := CurrentObj.Parent;
    for i := 0 to (CurrentObj as TWinControl).ControlCount - 1 do
      if (CurrentObj as TWinControl).Controls[i] = childControl then
        if i = (CurrentObj as TWinControl).ControlCount - 1 then
        begin
          Result := BackToParent;
        end
        else
          // repeat...
          Item := i + 1;
  end;
end;

function TChildIt.Next: Boolean;
begin
  Result := True;
  if (Item >= 0) and
    (((CurrentObj as TWinControl).Controls [Item] as TWinControl).ControlCount > 0) then
  begin
    // drill down into currentobj children
    CurrentObj := (CurrentObj as TWinControl).Controls [Item];
    Item := 0;
  end
  else if {(Item >= 0) and }(Item < (CurrentObj as TWinControl).ControlCount - 1) then
    Inc (Item)
  else
  begin
    Result := BackToParent;
  end;
end;

end.
