unit singleform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TSingle = class (TObject)
  class var
    Instance: TObject;
    nCount: Integer;
  public
    class function NewInstance: TObject; override;
    procedure FreeInstance; override;
  public
    SomeData: Integer;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    s1: TSingle;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TSingle }

//var
//  Instance: TObject = nil;
//  nCount: Integer = 0;

procedure TSingle.FreeInstance;
begin
  Dec (nCount);
  if nCount = 0 then
  begin
    inherited FreeInstance;
    Instance := nil;
  end;
end;

class function TSingle.NewInstance: TObject;
begin
  if not Assigned (Instance) then
  begin
    Instance := inherited NewInstance;
    (Instance as TSingle).SomeData := Random (100000);
  end;
  Result := Instance;
  Inc (nCount);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  s2: TSingle;
begin
  s2 := TSingle.Create;
  Memo1.Lines.Add ('s2 [' + IntToStr (s2.SomeData) + ']: ' + IntToStr (Integer (Pointer (s2))));
  s2.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  S1 := TSingle.Create;
  Memo1.Lines.Add ('s1 [' + IntToStr (s1.SomeData) + ']: ' + IntToStr (Integer (Pointer (s1))));
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  s3: TSingle;
begin
  s3 := TSingle.Create;
  Memo1.Lines.Add ('s3 [' + IntToStr (s3.SomeData) + ']: ' + IntToStr (Integer (Pointer (s3))));
  s3.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  FreeAndNil(s1);
  TButton.Create (self);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  S1 := TSingle.Create;
  Memo1.Lines.Add ('s1 [' + IntToStr (s1.SomeData) + ']: ' + IntToStr (Integer (Pointer (s1))));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  s1.Free;
end;

end.
